Imports System.Xml

Public Class Form1
    Inherits System.Windows.Forms.Form

    Private Regions As New Collection
    Private NeedNeighbors As Boolean = True
    Private Colors() As Color = {Color.Red, Color.LightGreen, Color.Blue, Color.Yellow, Color.Cyan}

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents dlgOpen As System.Windows.Forms.OpenFileDialog
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Friend WithEvents MenuItem1 As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileOpen As System.Windows.Forms.MenuItem
    Friend WithEvents MenuItem2 As System.Windows.Forms.MenuItem
    Friend WithEvents mnuColorFiveColor As System.Windows.Forms.MenuItem
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.dlgOpen = New System.Windows.Forms.OpenFileDialog
        Me.MainMenu1 = New System.Windows.Forms.MainMenu
        Me.MenuItem1 = New System.Windows.Forms.MenuItem
        Me.mnuFileOpen = New System.Windows.Forms.MenuItem
        Me.MenuItem2 = New System.Windows.Forms.MenuItem
        Me.mnuColorFiveColor = New System.Windows.Forms.MenuItem
        '
        'dlgOpen
        '
        Me.dlgOpen.Filter = "Map Files|*.map|All Files|*.*"
        Me.dlgOpen.Title = "Select Map"
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItem1, Me.MenuItem2})
        '
        'MenuItem1
        '
        Me.MenuItem1.Index = 0
        Me.MenuItem1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuFileOpen})
        Me.MenuItem1.Text = "&File"
        '
        'mnuFileOpen
        '
        Me.mnuFileOpen.Index = 0
        Me.mnuFileOpen.Shortcut = System.Windows.Forms.Shortcut.CtrlO
        Me.mnuFileOpen.Text = "&Open..."
        '
        'MenuItem2
        '
        Me.MenuItem2.Index = 1
        Me.MenuItem2.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuColorFiveColor})
        Me.MenuItem2.Text = "&Color"
        '
        'mnuColorFiveColor
        '
        Me.mnuColorFiveColor.Index = 0
        Me.mnuColorFiveColor.Shortcut = System.Windows.Forms.Shortcut.F5
        Me.mnuColorFiveColor.Text = "&Five-Color"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(344, 313)
        Me.Menu = Me.MainMenu1
        Me.Name = "Form1"
        Me.Text = "MapColor []"

    End Sub

#End Region

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        dlgOpen.InitialDirectory = Application.ExecutablePath
    End Sub

    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        e.Graphics.Clear(Me.BackColor)

        ' Make the regions draw themselves.
        For Each rgn As MapRegion In Regions
            rgn.DrawRegion(e.Graphics)
        Next rgn
    End Sub

    Private Sub mnuFileOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileOpen.Click
        If dlgOpen.ShowDialog() = DialogResult.OK Then
            ' Load the file.
            LoadMap(dlgOpen.FileName)

            Dim file_title As String = dlgOpen.FileName
            file_title = file_title.Substring(file_title.LastIndexOf("\") + 1)
            Me.Text = "MapColor [" & file_title & "]"

            ' Redraw.
            Invalidate()
        End If
    End Sub

    ' Load a map file.
    Private Sub LoadMap(ByVal fname As String)
        Dim xml_document As New XmlDocument
        xml_document.Load(fname)

        ' Read the regions.
        Regions = New Collection
        Dim rgn As MapRegion
        Dim i As Integer
        For Each xml_node As XmlElement In xml_document.DocumentElement.ChildNodes
            rgn = New MapRegion
            rgn.Number = i
            Regions.Add(rgn, rgn.Number.ToString("r#"))
            rgn.LoadData(xml_node)
            i += 1
        Next xml_node

        NeedNeighbors = True
    End Sub

    ' Five-color the map.
    Private Sub mnuColorFiveColor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuColorFiveColor.Click
        ' Assign the colors.
        AssignColors()

        ' Redraw.
        Invalidate()
    End Sub

    ' Five-color the map.
    Private Sub AssignColors()
        Dim all_regions As New Collection
        Dim rgn As MapRegion
        Dim n1 As MapRegion
        Dim n2 As MapRegion
        Dim stack As New Collection
        Dim obj As Object
        Dim color_used(4) As Boolean
        Dim i As Integer
        Dim found_one As Boolean

        ' Make the adjacency lists.
        FindNeighbors()

        ' Make the regions copy their neighbor lists.
        For Each rgn In Regions
            rgn.SaveNeighbors()
        Next rgn

        ' Save a copy of the region list.
        For Each rgn In Regions
            all_regions.Add(rgn)
        Next rgn

        ' Push regions onto the stack.
        Do While Regions.Count > 0
            ' Look for regions with degree < 5.
            found_one = False
            For Each rgn In Regions
                If rgn.Neighbors.Count < 5 Then
                    found_one = True
                    Exit For
                End If
            Next rgn

            ' If we did not find one, look for a
            ' node with degree 5 with two mutually
            ' non-adjacent children of degree <= 7.
            If Not found_one Then
                For Each rgn In Regions
                    If rgn.FindNonAdjacents(n1, n2) Then
                        found_one = True
                        Exit For
                    End If
                Next rgn

                ' If we still did not find one, there's
                ' something wrong.
                If Not found_one Then
                    MsgBox("Error finding node to remove.")
                    Exit Do
                End If

                ' Push rgn and its adjacency list
                ' onto the stack.
                stack.Add(rgn)
                stack.Add(rgn.Neighbors)

                ' Remove the node from the graph.
                rgn.RemoveFromGraph()
                Regions.Remove(rgn.Number.ToString("r#"))

                ' Associate n1 and n2.
                n1.AssociateWith(n2)

                ' Push n1 and n2 onto the stack.
                stack.Add(n1)
                stack.Add(n2)

                ' Remove n1 from the graph.
                n1.RemoveFromGraph()
                Regions.Remove(n1.Number.ToString("r#"))
            Else
                ' Push rgn and its adjacency list
                ' onto the stack.
                stack.Add(rgn)
                stack.Add(rgn.Neighbors)

                ' Remove the node from the graph.
                rgn.RemoveFromGraph()
                Regions.Remove(rgn.Number.ToString("r#"))
            End If
        Loop

        ' Pop regions off the stack and color them.
        Do While stack.Count > 0
            obj = stack(stack.Count)
            stack.Remove(stack.Count)
            rgn = stack(stack.Count)
            stack.Remove(stack.Count)

            If TypeOf obj Is Collection Then
                For i = 0 To 4
                    color_used(i) = False
                Next i

                ' Assign rgn a color different from
                ' those used by its neighbors.
                For Each n1 In obj
                    For i = 0 To 4
                        If Colors(i).Equals(n1.RegionColor) Then
                            color_used(i) = True
                            Exit For
                        End If
                    Next i
                Next n1

                ' See what color is left.
                For i = 0 To 4
                    If Not color_used(i) Then Exit For
                Next i

                ' If we did not find a usable color,
                ' there's something wrong.
                If i > 4 Then
                    MsgBox("Error finding color for node.")
                Else
                    rgn.RegionColor = Colors(i)
                End If
            Else
                ' Assign rgn the same color as its
                ' associated node.
                rgn.RegionColor = obj.RegionColor
            End If
        Loop

        ' Restore the region list.
        For Each rgn In all_regions
            Regions.Add(rgn, rgn.Number.ToString("r#"))
        Next rgn

        ' Restore the saved neighbor lists.
        For Each rgn In Regions
            rgn.RestoreNeighbors()
        Next rgn
    End Sub

    ' Find each region's neighbors.
    Private Sub FindNeighbors()
        ' Do nothing if we already know the neighbors.
        If Not NeedNeighbors Then Exit Sub

        ' Clear out the neighbor collections.
        For Each rgn As MapRegion In Regions
            rgn.Neighbors = New Collection
        Next rgn

        ' Find the neighbors.
        Dim i1 As Integer
        Dim i2 As Integer
        Dim rgn1 As MapRegion
        For i1 = 1 To Regions.Count - 1
            rgn1 = Regions(i1)
            For i2 = i1 + 1 To Regions.Count
                rgn1.CheckNeighbor(Regions(i2))
            Next i2
        Next i1

        NeedNeighbors = False
    End Sub
End Class
