Imports System.Math

Public Class FlowLink
    Public Node1 As FlowNode
    Public Node2 As FlowNode
    Public Capacity As Integer
    Public Flow As Integer

    Public Sub New(ByVal n1 As FlowNode, ByVal n2 As FlowNode, ByVal cap As Integer)
        Node1 = n1
        Node2 = n2
        Capacity = cap
    End Sub

    ' Link these nodes.
    Public Shared Function LinkNodes(ByVal n1 As FlowNode, ByVal n2 As FlowNode, ByVal cap As Integer) As FlowLink
        Dim new_link As New FlowLink(n1, n2, cap)
        n1.Links.Add(new_link)
        n2.Links.Add(new_link)
        Return new_link
    End Function

    ' Draw the link.
    Public Sub DrawLink(ByVal gr As Graphics, ByVal fnt As Font)
        ' Draw the link.
        If Flow = 0 Then
            gr.DrawLine( _
                New Pen(Color.Black, 1), _
                Node1.Pt, _
                Node2.Pt)
        Else
            gr.DrawLine( _
                New Pen(Color.PaleGreen, 2 * Flow + 1), _
                Node1.Pt, _
                Node2.Pt)
        End If

        ' Draw the capacity and flow.
        Dim X As Integer = (Node1.Pt.X + Node2.Pt.X) / 2
        Dim Y As Integer = (Node1.Pt.Y + Node2.Pt.Y) / 2
        Dim rectf As New RectangleF(X - 100, Y - 100, 200, 200)
        Dim string_format As New StringFormat
        string_format.Alignment = StringAlignment.Center
        string_format.LineAlignment = StringAlignment.Center
        gr.DrawString( _
            Flow.ToString & "/" & Capacity.ToString, _
            fnt, Brushes.Black, rectf, string_format)
    End Sub
End Class
