Imports System.Xml

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents MainMenu1 As System.Windows.Forms.MainMenu
    Friend WithEvents dlgOpen As System.Windows.Forms.OpenFileDialog
    Friend WithEvents MenuItem1 As System.Windows.Forms.MenuItem
    Friend WithEvents mnuFileOpen As System.Windows.Forms.MenuItem
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.MainMenu1 = New System.Windows.Forms.MainMenu
        Me.MenuItem1 = New System.Windows.Forms.MenuItem
        Me.mnuFileOpen = New System.Windows.Forms.MenuItem
        Me.dlgOpen = New System.Windows.Forms.OpenFileDialog
        '
        'MainMenu1
        '
        Me.MainMenu1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.MenuItem1})
        '
        'MenuItem1
        '
        Me.MenuItem1.Index = 0
        Me.MenuItem1.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuFileOpen})
        Me.MenuItem1.Text = "&File"
        '
        'mnuFileOpen
        '
        Me.mnuFileOpen.Index = 0
        Me.mnuFileOpen.Shortcut = System.Windows.Forms.Shortcut.CtrlO
        Me.mnuFileOpen.Text = "&Open..."
        '
        'dlgOpen
        '
        Me.dlgOpen.Filter = "Flow Files|*.flw|All Files|*.*"
        Me.dlgOpen.Title = "Select Flow File"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(292, 273)
        Me.Menu = Me.MainMenu1
        Me.Name = "Form1"
        Me.Text = "MaxFlow []"

    End Sub

#End Region

    Private m_Nodes As New Collection
    Private m_Links As New Collection
    Private m_Source As FlowNode
    Private m_Sink As FlowNode

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        dlgOpen.InitialDirectory = Application.ExecutablePath
    End Sub

    Private Sub mnuFileOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileOpen.Click
        If dlgOpen.ShowDialog() = DialogResult.OK Then
            ' Load the file.
            LoadMap(dlgOpen.FileName)

            Dim file_title As String = dlgOpen.FileName
            file_title = file_title.Substring(file_title.LastIndexOf("\") + 1)
            Me.Text = "MaxFlow [" & file_title & "]"

            ' Redraw.
            Invalidate()
        End If
    End Sub

    ' Load a map file.
    Private Sub LoadMap(ByVal fname As String)
        Dim xml_document As New XmlDocument
        xml_document.Load(fname)

        ' Read the nodes.
        m_Nodes = New Collection
        m_Links = New Collection
        Dim new_node As FlowNode
        For Each xml_node As XmlElement In xml_document.DocumentElement.ChildNodes
            new_node = New FlowNode( _
                xml_node.GetAttribute("X"), _
                xml_node.GetAttribute("Y"), _
                xml_node.GetAttribute("Name"))
            m_Nodes.Add(new_node, new_node.Name)
        Next xml_node

        ' Read the link information.
        Dim node_element As XmlElement
        Dim neighbor As FlowNode
        For i As Integer = 1 To m_Nodes.Count
            new_node = m_Nodes(i)
            node_element = xml_document.DocumentElement.ChildNodes(i - 1)
            For Each neighbor_node As XmlElement In node_element.ChildNodes
                ' Find the neighbor node.
                neighbor = m_Nodes(neighbor_node.GetAttribute("Name"))

                ' Link to this node.
                m_Links.Add(FlowLink.LinkNodes( _
                    new_node, _
                    neighbor, _
                    neighbor_node.GetAttribute("Cap")))
            Next neighbor_node
        Next i

        m_Source = Nothing
        m_Sink = Nothing
    End Sub

    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
        e.Graphics.Clear(Me.BackColor)

        ' Draw links.
        For Each flow_node As FlowNode In m_Nodes
            flow_node.DrawLinks(e.Graphics, Me.Font)
        Next flow_node

        ' Draw nodes.
        For Each flow_node As FlowNode In m_Nodes
            flow_node.DrawNode(e.Graphics)
        Next flow_node
    End Sub

    Private Sub Form1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown
        ' See if this is the left or right button.
        If e.Button = MouseButtons.Left Then
            If Not (m_Source Is Nothing) Then m_Source.IsSource = False
            m_Source = NearestNode(e.X, e.Y)
            m_Source.IsSource = True
        ElseIf e.Button = MouseButtons.Right Then
            If Not (m_Sink Is Nothing) Then m_Sink.IsSink = False
            m_Sink = NearestNode(e.X, e.Y)
            m_Sink.IsSink = True
        End If

        ' See if we have both a source and sink.
        If Not (m_Source Is Nothing) And _
           Not (m_Sink Is Nothing) _
        Then
            ' Calculate max flows.
            CalculateFlows()
        End If

        ' Redraw.
        Invalidate()
    End Sub

    ' Find the node nearest to this point.
    Private Function NearestNode(ByVal X As Integer, ByVal Y As Integer) As FlowNode
        Dim best_node As FlowNode
        Dim best_dist As Single = Single.MaxValue
        Dim test_dist As Single
        Dim dx As Single
        Dim dy As Single

        For Each test_node As FlowNode In m_Nodes
            dx = test_node.Pt.X - X
            dy = test_node.Pt.Y - Y
            test_dist = dx * dx + dy * dy
            If best_dist > test_dist Then
                best_dist = test_dist
                best_node = test_node
            End If
        Next test_node

        Return best_node
    End Function

    ' Calculate the maximal flows.
    Private Sub CalculateFlows()
        ' Reset node statuses.
        For Each flow_node As FlowNode In m_Nodes
            flow_node.Status = FlowNode.NodeStatusEnum.statNotInList
        Next flow_node

        ' Remove previous link flows.
        For Each flow_link As FlowLink In m_Links
            flow_link.Flow = 0
        Next flow_link

        ' Repeatedly find augmenting paths.
        Dim candidates As Collection
        Dim selected_node As FlowNode
        Dim neighbor_node As FlowNode
        Dim residual_capacity As Integer
        Dim min_residual As Integer
        Dim selected_link As FlowLink
        Do
            ' Reset the nodes' Status and AugmentingLink.
            For Each selected_node In m_Nodes
                selected_node.Status = FlowNode.NodeStatusEnum.statNotInList
                selected_node.AugmentingLink = Nothing
            Next selected_node

            ' Start the candidates list with only
            ' the source node.
            candidates = New Collection
            candidates.Add(m_Source)
            m_Source.Status = FlowNode.NodeStatusEnum.statNowInList

            ' Repeatedly extend the augmenting "tree"
            ' until the candidate list is empty.
            Do While candidates.Count > 0
                ' Remove the first item from the list.
                selected_node = candidates(1)
                candidates.Remove(1)
                selected_node.Status = FlowNode.NodeStatusEnum.statWasInList

                ' Examine links out of this node.
                For Each my_link As FlowLink In selected_node.Links
                    ' See if this is a "real" link
                    ' or a "back" link.
                    If my_link.Node1 Is selected_node Then
                        ' Real link.
                        neighbor_node = my_link.Node2
                        residual_capacity = my_link.Capacity - my_link.Flow
                    Else
                        ' Back link.
                        neighbor_node = my_link.Node1
                        residual_capacity = my_link.Flow
                    End If

                    ' See if the neighbor has never 
                    ' been on the candidate list
                    ' and has residual capacity > 0.
                    If (neighbor_node.Status = FlowNode.NodeStatusEnum.statNotInList) And _
                        (residual_capacity > 0) _
                    Then
                        ' Add this node to the list.
                        candidates.Add(neighbor_node)
                        neighbor_node.Status = FlowNode.NodeStatusEnum.statNowInList
                        neighbor_node.AugmentingLink = my_link
                    End If
                Next my_link

                ' Stop when the sink is procesed.
                If Not (m_Sink.AugmentingLink Is Nothing) _
                    Then Exit Do
            Loop ' Continue processing candidate list.

            ' If we found no augmenting path, we're done.
            If m_Sink.AugmentingLink Is Nothing Then Exit Do

            ' Process the augmenting path.

            ' Process the augmenting path.
            ' Find the minimum residual 
            ' along the augmenting path.
            min_residual = Integer.MaxValue
            selected_node = m_Sink
            Do While Not (selected_node Is m_Source)
                ' Get the residual capacity.
                selected_link = selected_node.AugmentingLink
                If selected_link.Node2 Is selected_node Then
                    ' Real link.
                    neighbor_node = selected_link.Node1
                    residual_capacity = selected_link.Capacity - selected_link.Flow
                    selected_node = selected_link.Node1
                Else
                    ' Back link.
                    neighbor_node = selected_link.Node2
                    residual_capacity = selected_link.Flow
                    selected_node = selected_link.Node2
                End If

                ' See if it is smaller.
                If min_residual > residual_capacity _
                    Then min_residual = residual_capacity
            Loop

            ' Update the flows along the path.
            selected_node = m_Sink
            Do While Not (selected_node Is m_Source)
                ' Update the link's flow.
                selected_link = selected_node.AugmentingLink
                If selected_link.Node2 Is selected_node Then
                    ' Real link.
                    selected_link.Flow += min_residual
                    selected_node = selected_link.Node1
                Else
                    ' Back link.
                    selected_link.Flow -= min_residual
                    selected_node = selected_link.Node2
                End If
            Loop
        Loop ' Continue finding augmenting paths.
    End Sub
End Class
