Public Class PathNode
    Public Enum NodeStatusEnum
        statNotInList
        statNowInList
        statWasInList
    End Enum

    Public Pt As New Point
    Public Links As New Collection

    Public FromLink As PathLink
    Public BestCost As Single
    Public Status As NodeStatusEnum
    Public IsRoot As Boolean

    Public Sub New(ByVal new_x As Integer, ByVal new_y As Integer)
        Pt.X = new_x
        Pt.Y = new_y
    End Sub

    ' Draw the node's links.
    Public Sub DrawLinks(ByVal gr As Graphics)
        For Each path_link As PathLink In Links
            ' Only draw it we're the first node.
            If Me Is path_link.Node1 Then
                If path_link.InPathTree Then
                    gr.DrawLine( _
                        New Pen(Color.Red, 4), _
                        Pt, _
                        path_link.Node2.Pt)
                Else
                    gr.DrawLine( _
                        Pens.Black, _
                        Pt, _
                        path_link.Node2.Pt)
                End If
            End If
        Next path_link
    End Sub

    ' Draw the node.
    Public Sub DrawNode(ByVal gr As Graphics)
        Dim NODE_R As Single = 3
        Dim rect As New Rectangle( _
            Pt.X - NODE_R, _
            Pt.Y - NODE_R, _
            2 * NODE_R, _
            2 * NODE_R)
        If IsRoot Then
            gr.FillEllipse(Brushes.Yellow, rect)
        Else
            gr.FillEllipse(Brushes.White, rect)
        End If
        gr.DrawEllipse(Pens.Black, rect)
    End Sub
End Class
